twitter4j.api

## Interface FriendsFollowersResources

All Known Subinterfaces:
  Twitter

    public interface FriendsFollowersResources

Author:
  Joern Huxhorn - jhuxhorn at googlemail.com, Mocel - docel77 at gmail.com

### Method Summary

All Methods Instance Methods Abstract Methods
`User` `createFriendship(long userId)` Allows the authenticating users to follow the user specified in the ID parameter. Returns the befriended user in the requested format when successful.
`User` `createFriendship(long userId, boolean follow)` Allows the authenticating users to follow the user specified in the ID parameter. Returns the befriended user in the requested format when successful.
`User` `createFriendship(String screenName)` Allows the authenticating users to follow the user specified in the ID parameter. Returns the befriended user in the requested format when successful.
`User` `createFriendship(String screenName, boolean follow)` Allows the authenticating users to follow the user specified in the ID parameter. Returns the befriended user in the requested format when successful.
`User` `destroyFriendship(long userId)` Allows the authenticating users to unfollow the user specified in the ID parameter. Returns the unfollowed user in the requested format when successful.
`User` `destroyFriendship(String screenName)` Allows the authenticating users to unfollow the user specified in the ID parameter. Returns the unfollowed user in the requested format when successful.
`IDs` `getFollowersIDs(long cursor)` Returns an array of numeric IDs for every user the specified user is followed by.
`IDs` `getFollowersIDs(long userId, long cursor)` Returns an array of numeric IDs for every user the specified user is followed by.
`IDs` `getFollowersIDs(long userId, long cursor, int count)` Returns an array of numeric IDs for every user the specified user is followed by.
`IDs` `getFollowersIDs(String screenName, long cursor)` Returns an array of numeric IDs for every user the specified user is followed by.
`IDs` `getFollowersIDs(String screenName, long cursor, int count)` Returns an array of numeric IDs for every user the specified user is followed by.
`PagableResponseList<User>` `getFollowersList(long userId, long cursor)` Returns a cursored collection of user objects for users following the specified user. At this time, results are ordered with the most recent following first — however, this ordering is subject to unannounced change and eventual consistency issues.
`PagableResponseList<User>` `getFollowersList(long userId, long cursor, int count)` Returns a cursored collection of user objects for users following the specified user. At this time, results are ordered with the most recent following first — however, this ordering is subject to unannounced change and eventual consistency issues.
`PagableResponseList<User>` `getFollowersList(long userId, long cursor, int count, boolean skipStatus, boolean includeUserEntities)` Returns a cursored collection of user objects for users following the specified user. At this time, results are ordered with the most recent following first — however, this ordering is subject to unannounced change and eventual consistency issues.
`PagableResponseList<User>` `getFollowersList(String screenName, long cursor)` Returns a cursored collection of user objects for users following the specified user. At this time, results are ordered with the most recent following first — however, this ordering is subject to unannounced change and eventual consistency issues.
`PagableResponseList<User>` `getFollowersList(String screenName, long cursor, int count)` Returns a cursored collection of user objects for users following the specified user. At this time, results are ordered with the most recent following first — however, this ordering is subject to unannounced change and eventual consistency issues.
`PagableResponseList<User>` `getFollowersList(String screenName, long cursor, int count, boolean skipStatus, boolean includeUserEntities)` Returns a cursored collection of user objects for users following the specified user. At this time, results are ordered with the most recent following first — however, this ordering is subject to unannounced change and eventual consistency issues.
`IDs` `getFriendsIDs(long cursor)` Returns an array of numeric IDs for every user the authenticating user is following.
`IDs` `getFriendsIDs(long userId, long cursor)` Returns an array of numeric IDs for every user the specified user is following.
`IDs` `getFriendsIDs(long userId, long cursor, int count)` Returns an array of numeric IDs for every user the specified user is following.
`IDs` `getFriendsIDs(String screenName, long cursor)` Returns an array of numeric IDs for every user the specified user is following.
`IDs` `getFriendsIDs(String screenName, long cursor, int count)` Returns an array of numeric IDs for every user the specified user is following.
`PagableResponseList<User>` `getFriendsList(long userId, long cursor)` Returns a cursored collection of user objects for every user the specified user is following (otherwise known as their "friends"). At this time, results are ordered with the most recent following first — however, this ordering is subject to unannounced change and eventual consistency issues.
`PagableResponseList<User>` `getFriendsList(long userId, long cursor, int count)` Returns a cursored collection of user objects for every user the specified user is following (otherwise known as their "friends"). At this time, results are ordered with the most recent following first — however, this ordering is subject to unannounced change and eventual consistency issues.

`PagableResponseList<User>`

`getFriendsList(long userId, long cursor, int count, boolean skipStatus, boolean includeUserEntities)`
Returns a cursored collection of user objects for every user the specified user is following (otherwise known as their "friends").
At this time, results are ordered with the most recent following first — however, this ordering is subject to unannounced change and eventual consistency issues.

`PagableResponseList<User>` `getFriendsList(String screenName, long cursor)` Returns a cursored collection of user objects for every user the specified user is following (otherwise known as their "friends"). At this time, results are ordered with the most recent following first — however, this ordering is subject to unannounced change and eventual consistency issues.
`PagableResponseList<User>` `getFriendsList(String screenName, long cursor, int count)` Returns a cursored collection of user objects for every user the specified user is following (otherwise known as their "friends"). At this time, results are ordered with the most recent following first — however, this ordering is subject to unannounced change and eventual consistency issues.

`PagableResponseList<User>`

`getFriendsList(String screenName, long cursor, int count, boolean skipStatus, boolean includeUserEntities)`
Returns a cursored collection of user objects for every user the specified user is following (otherwise known as their "friends").
At this time, results are ordered with the most recent following first — however, this ordering is subject to unannounced change and eventual consistency issues.

`IDs` `getIncomingFriendships(long cursor)` Returns an array of numeric IDs for every user who has a pending request to follow the authenticating user.
`IDs` `getNoRetweetsFriendships()` Returns a collection of user IDs that the currently authenticated user does not want to receive retweets from.
`IDs` `getOutgoingFriendships(long cursor)` Returns an array of numeric IDs for every protected user for whom the authenticating user has a pending follow request.
`ResponseList<Friendship>` `lookupFriendships(long... ids)` Returns the relationship of the authenticating user to the specified users.
`ResponseList<Friendship>` `lookupFriendships(String... screenNames)` Returns the relationship of the authenticating user to the specified users.
`Relationship` `showFriendship(long sourceId, long targetId)` Returns detailed information about the relationship between two users.
`Relationship` `showFriendship(String sourceScreenName, String targetScreenName)` Returns detailed information about the relationship between two users.
`Relationship` `updateFriendship(long userId, boolean enableDeviceNotification, boolean retweets)` Allows you to enable or disable retweets and device notifications from the specified user.
`Relationship` `updateFriendship(String screenName, boolean enableDeviceNotification, boolean retweets)` Allows you to enable or disable retweets and device notifications from the specified user.

### Method Detail

#### getNoRetweetsFriendships

    IDs getNoRetweetsFriendships()
                          throws TwitterException

Returns a collection of user IDs that the currently authenticated user does not want to receive retweets from.
This method calls https://api.twitter.com/1.1/friendships/no_retweets/ids.json

Returns:
  a collection of numeric IDs that the currently authenticated user does not want to receive retweets from.
Throws:
  `TwitterException` - when Twitter service or network is unavailable
Since:
  Twitter4J 4.0.2
See Also:
  GET friendships/no_retweets/ids | Twitter Developers

#### getFriendsIDs

    IDs getFriendsIDs(long cursor)
               throws TwitterException

Returns an array of numeric IDs for every user the authenticating user is following.
This method calls https://api.twitter.com/1.1/friends/ids.json

Parameters:
  `cursor` - Causes the list of connections to be broken into pages of no more than 5000 IDs at a time. The number of IDs returned is not guaranteed to be 5000 as suspended users are filtered out after connections are queried.
  To begin paging provide a value of -1 as the cursor. The response from the API will include a previous_cursor and next_cursor to allow paging back and forth.
Returns:
  an array of numeric IDs for every user the authenticating user is following
Throws:
  `TwitterException` - when Twitter service or network is unavailable
Since:
  Twitter4J 2.0.10
See Also:
  GET friends/ids | Twitter Developers

#### getFriendsIDs

    IDs getFriendsIDs(long userId,
                      long cursor)
               throws TwitterException

Returns an array of numeric IDs for every user the specified user is following.
This method calls https://api.twitter.com/1.1/friends/ids.json

Parameters:
  `userId` - Specifies the ID of the user for whom to return the friends list.
  `cursor` - Causes the list of connections to be broken into pages of no more than 5000 IDs at a time. The number of IDs returned is not guaranteed to be 5000 as suspended users are filtered out after connections are queried.
  To begin paging provide a value of -1 as the cursor. The response from the API will include a previous_cursor and next_cursor to allow paging back and forth.
Returns:
  an array of numeric IDs for every user the specified user is following
Throws:
  `TwitterException` - when Twitter service or network is unavailable
Since:
  Twitter4J 2.0.10
See Also:
  GET friends/ids | Twitter Developers

#### getFriendsIDs

    IDs getFriendsIDs(long userId,
                      long cursor,
                      int count)
               throws TwitterException

Returns an array of numeric IDs for every user the specified user is following.
This method calls http://api.twitter.com/1.1/friends/ids.json

Parameters:
  `userId` - Specifies the ID of the user for whom to return the friends list.
  `cursor` - Causes the list of connections to be broken into pages of no more than 5000 IDs at a time. The number of IDs returned is not guaranteed to be 5000 as suspended users are filtered out after connections are queried.
  To begin paging provide a value of -1 as the cursor. The response from the API will include a previous_cursor and next_cursor to allow paging back and forth.
  `count` - Specifies the number of IDs attempt retrieval of, up to a maximum of 5,000 per distinct request. The value of count is best thought of as a limit to the number of results to return.
  When using the count parameter with this method, it is wise to use a consistent count value across all requests to the same user's collection.
  Usage of this parameter is encouraged in environments where all 5,000 IDs constitutes too large of a response.
Returns:
  an array of numeric IDs for every user the specified user is following
Throws:
  `TwitterException` - when Twitter service or network is unavailable
Since:
  Twitter4J 4.0.2
See Also:
  GET friends/ids | Twitter Developers

#### getFriendsIDs

    IDs getFriendsIDs(String screenName,
                      long cursor)
               throws TwitterException

Returns an array of numeric IDs for every user the specified user is following.
This method calls https://api.twitter.com/1.1/friends/ids.json

Parameters:
  `screenName` - Specifies the screen name of the user for whom to return the friends list.
  `cursor` - Causes the list of connections to be broken into pages of no more than 5000 IDs at a time. The number of IDs returned is not guaranteed to be 5000 as suspended users are filtered out after connections are queried.
  To begin paging provide a value of -1 as the cursor. The response from the API will include a previous_cursor and next_cursor to allow paging back and forth.
Returns:
  an array of numeric IDs for every user the specified user is following
Throws:
  `TwitterException` - when Twitter service or network is unavailable
Since:
  Twitter4J 2.0.10
See Also:
  GET friends/ids | Twitter Developers

#### getFriendsIDs

    IDs getFriendsIDs(String screenName,
                      long cursor,
                      int count)
               throws TwitterException

Returns an array of numeric IDs for every user the specified user is following.
This method calls http://api.twitter.com/1.1/friends/ids.json

Parameters:
  `screenName` - Specifies the screen name of the user for whom to return the friends list.
  `cursor` - Causes the list of connections to be broken into pages of no more than 5000 IDs at a time. The number of IDs returned is not guaranteed to be 5000 as suspended users are filtered out after connections are queried.
  To begin paging provide a value of -1 as the cursor. The response from the API will include a previous_cursor and next_cursor to allow paging back and forth.
  `count` - Specifies the number of IDs attempt retrieval of, up to a maximum of 5,000 per distinct request. The value of count is best thought of as a limit to the number of results to return.
  When using the count parameter with this method, it is wise to use a consistent count value across all requests to the same user's collection.
  Usage of this parameter is encouraged in environments where all 5,000 IDs constitutes too large of a response.
Returns:
  an array of numeric IDs for every user the specified user is following
Throws:
  `TwitterException` - when Twitter service or network is unavailable
Since:
  Twitter4J 4.0.2
See Also:
  GET friends/ids | Twitter Developers

#### getFollowersIDs

    IDs getFollowersIDs(long cursor)
                 throws TwitterException

Returns an array of numeric IDs for every user the specified user is followed by.
This method calls https://api.twitter.com/1.1/followers/ids.json

Parameters:
  `cursor` - Causes the list of connections to be broken into pages of no more than 5000 IDs at a time. The number of IDs returned is not guaranteed to be 5000 as suspended users are filtered out after connections are queried.
  To begin paging provide a value of -1 as the cursor. The response from the API will include a previous_cursor and next_cursor to allow paging back and forth.
Returns:
  The ID or screen_name of the user to retrieve the friends ID list for.
Throws:
  `TwitterException` - when Twitter service or network is unavailable
Since:
  Twitter4J 2.0.10
See Also:
  GET followers/ids | Twitter Developers

#### getFollowersIDs

    IDs getFollowersIDs(long userId,
                        long cursor)
                 throws TwitterException

Returns an array of numeric IDs for every user the specified user is followed by.
This method calls https://api.twitter.com/1.1/followers/ids.json

Parameters:
  `userId` - Specifies the ID of the user for whom to return the followers list.
  `cursor` - Causes the list of connections to be broken into pages of no more than 5000 IDs at a time. The number of IDs returned is not guaranteed to be 5000 as suspended users are filtered out after connections are queried.
  To begin paging provide a value of -1 as the cursor. The response from the API will include a previous_cursor and next_cursor to allow paging back and forth.
Returns:
  The ID or screen_name of the user to retrieve the friends ID list for.
Throws:
  `TwitterException` - when Twitter service or network is unavailable
Since:
  Twitter4J 2.0.10
See Also:
  GET followers/ids | Twitter Developers

#### getFollowersIDs

    IDs getFollowersIDs(long userId,
                        long cursor,
                        int count)
                 throws TwitterException

Returns an array of numeric IDs for every user the specified user is followed by.
This method calls http://api.twitter.com/1.1/followers/ids.json

Parameters:
  `userId` - Specifies the ID of the user for whom to return the followers list.
  `cursor` - Causes the list of connections to be broken into pages of no more than 5000 IDs at a time. The number of IDs returned is not guaranteed to be 5000 as suspended users are filtered out after connections are queried.
  To begin paging provide a value of -1 as the cursor. The response from the API will include a previous_cursor and next_cursor to allow paging back and forth.
  `count` - Specifies the number of IDs attempt retrieval of, up to a maximum of 5,000 per distinct request.
  The value of count is best thought of as a limit to the number of results to return.
  When using the count parameter with this method, it is wise to use a consistent count value across all requests to the same user's collection. Usage of this parameter is encouraged in environments where all 5,000 IDs constitutes too large of a response.
Returns:
  The ID or screen_name of the user to retrieve the friends ID list for.
Throws:
  `TwitterException` - when Twitter service or network is unavailable
Since:
  Twitter4J 4.0.2
See Also:
  GET followers/ids | Twitter Developers

#### getFollowersIDs

    IDs getFollowersIDs(String screenName,
                        long cursor)
                 throws TwitterException

Returns an array of numeric IDs for every user the specified user is followed by.
This method calls https://api.twitter.com/1.1/followers/ids.json

Parameters:
  `screenName` - Specifies the screen name of the user for whom to return the followers list.
  `cursor` - Causes the list of connections to be broken into pages of no more than 5000 IDs at a time. The number of IDs returned is not guaranteed to be 5000 as suspended users are filtered out after connections are queried.
  To begin paging provide a value of -1 as the cursor. The response from the API will include a previous_cursor and next_cursor to allow paging back and forth.
Returns:
  The ID or screen_name of the user to retrieve the friends ID list for.
Throws:
  `TwitterException` - when Twitter service or network is unavailable
Since:
  Twitter4J 2.0.10
See Also:
  GET followers/ids | Twitter Developers

#### getFollowersIDs

    IDs getFollowersIDs(String screenName,
                        long cursor,
                        int count)
                 throws TwitterException

Returns an array of numeric IDs for every user the specified user is followed by.
This method calls http://api.twitter.com/1.1/followers/ids.json

Parameters:
  `screenName` - Specifies the screen name of the user for whom to return the followers list.
  `cursor` - Causes the list of connections to be broken into pages of no more than 5000 IDs at a time. The number of IDs returned is not guaranteed to be 5000 as suspended users are filtered out after connections are queried.
  To begin paging provide a value of -1 as the cursor. The response from the API will include a previous_cursor and next_cursor to allow paging back and forth.
  `count` - Specifies the number of IDs attempt retrieval of, up to a maximum of 5,000 per distinct request.
  The value of count is best thought of as a limit to the number of results to return.
  When using the count parameter with this method, it is wise to use a consistent count value across all requests to the same user's collection. Usage of this parameter is encouraged in environments where all 5,000 IDs constitutes too large of a response.
Returns:
  The ID or screen_name of the user to retrieve the friends ID list for.
Throws:
  `TwitterException` - when Twitter service or network is unavailable
Since:
  Twitter4J 4.0.2
See Also:
  GET followers/ids | Twitter Developers

#### lookupFriendships

    ResponseList<Friendship> lookupFriendships(long... ids)
                                        throws TwitterException

Returns the relationship of the authenticating user to the specified users.
This method has not been finalized and the interface is subject to change in incompatible ways.
This method calls https://api.twitter.com/1.1/friendships/lookup.json

Parameters:
  `ids` - array of the ids to lookup
Returns:
  list of Relationships
Throws:
  `TwitterException` - when Twitter service or network is unavailable
Since:
  Twitter4J 2.1.9
See Also:
  #newtwitter and the API - Twitter API Announcements | Google Group

#### lookupFriendships

    ResponseList<Friendship> lookupFriendships(String... screenNames)
                                        throws TwitterException

Returns the relationship of the authenticating user to the specified users.
This method has not been finalized and the interface is subject to change in incompatible ways.
This method calls https://api.twitter.com/1.1/friendships/lookup.json

Parameters:
  `screenNames` - array of the screen names to lookup
Returns:
  list of Relationships
Throws:
  `TwitterException` - when Twitter service or network is unavailable
Since:
  Twitter4J 2.1.9
See Also:
  #newtwitter and the API - Twitter API Announcements | Google Group

#### getIncomingFriendships

    IDs getIncomingFriendships(long cursor)
                        throws TwitterException

Returns an array of numeric IDs for every user who has a pending request to follow the authenticating user.
This method calls https://api.twitter.com/1.1/friendships/incoming.json

Parameters:
  `cursor` - Breaks the results into pages. A single page contains 5000 identifiers. Provide a value of -1 to begin paging.
Returns:
  an array of numeric IDs for every user who has a pending request to follow the authenticating user.
Throws:
  `TwitterException` - when Twitter service or network is unavailable
Since:
  Twitter4J 2.1.2
See Also:
  GET friendships/incoming | Twitter Developers

#### getOutgoingFriendships

    IDs getOutgoingFriendships(long cursor)
                        throws TwitterException

Returns an array of numeric IDs for every protected user for whom the authenticating user has a pending follow request.
This method calls https://api.twitter.com/1.1/friendships/outgoing.json

Parameters:
  `cursor` - Breaks the results into pages. A single page contains 5000 identifiers. Provide a value of -1 to begin paging.
Returns:
  an array of numeric IDs for every protected user for whom the authenticating user has a pending follow request.
Throws:
  `TwitterException` - when Twitter service or network is unavailable
Since:
  Twitter4J 2.1.2
See Also:
  GET friendships/outgoing | Twitter Developers

#### createFriendship

    User createFriendship(long userId)
                   throws TwitterException

Allows the authenticating users to follow the user specified in the ID parameter.
Returns the befriended user in the requested format when successful. Returns a string describing the failure condition when unsuccessful. If you are already friends with the user an HTTP 403 will be returned.
This method calls https://api.twitter.com/1.1/friendships/create/[id].json

Parameters:
  `userId` - the ID of the user to be befriended
Returns:
  the befriended user
Throws:
  `TwitterException` - when Twitter service or network is unavailable
Since:
  Twitter4J 2.1.0
See Also:
  POST friendships/create | Twitter Developers

#### createFriendship

    User createFriendship(String screenName)
                   throws TwitterException

Allows the authenticating users to follow the user specified in the ID parameter.
Returns the befriended user in the requested format when successful. Returns a string describing the failure condition when unsuccessful. If you are already friends with the user an HTTP 403 will be returned.
This method calls https://api.twitter.com/1.1/friendships/create/[id].json

Parameters:
  `screenName` - the screen name of the user to be befriended
Returns:
  the befriended user
Throws:
  `TwitterException` - when Twitter service or network is unavailable
Since:
  Twitter4J 2.0.1
See Also:
  POST friendships/create | Twitter Developers

#### createFriendship

    User createFriendship(long userId,
                          boolean follow)
                   throws TwitterException

Allows the authenticating users to follow the user specified in the ID parameter.
Returns the befriended user in the requested format when successful. Returns a string describing the failure condition when unsuccessful. If you are already friends with the user an HTTP 403 will be returned.
This method calls https://api.twitter.com/1.1/friendships/create/[id].json

Parameters:
  `userId` - the ID of the user to be befriended
  `follow` - Enable notifications for the target user in addition to becoming friends.
Returns:
  the befriended user
Throws:
  `TwitterException` - when Twitter service or network is unavailable
Since:
  Twitter4J 2.1.0
See Also:
  POST friendships/create | Twitter Developers

#### createFriendship

    User createFriendship(String screenName,
                          boolean follow)
                   throws TwitterException

Allows the authenticating users to follow the user specified in the ID parameter.
Returns the befriended user in the requested format when successful. Returns a string describing the failure condition when unsuccessful. If you are already friends with the user an HTTP 403 will be returned.
This method calls https://api.twitter.com/1.1/friendships/create/[id].json

Parameters:
  `screenName` - the screen name of the user to be befriended
  `follow` - Enable notifications for the target user in addition to becoming friends.
Returns:
  the befriended user
Throws:
  `TwitterException` - when Twitter service or network is unavailable
Since:
  Twitter4J 2.0.2
See Also:
  POST friendships/create | Twitter Developers

#### destroyFriendship

    User destroyFriendship(long userId)
                    throws TwitterException

Allows the authenticating users to unfollow the user specified in the ID parameter.
Returns the unfollowed user in the requested format when successful. Returns a string describing the failure condition when unsuccessful.
This method calls https://api.twitter.com/1.1/friendships/destroy/[id].json

Parameters:
  `userId` - the ID of the user for whom to request a list of friends
Returns:
  User
Throws:
  `TwitterException` - when Twitter service or network is unavailable
Since:
  Twitter4J 2.1.0
See Also:
  POST friendships/destroy | Twitter Developers

#### destroyFriendship

    User destroyFriendship(String screenName)
                    throws TwitterException

Allows the authenticating users to unfollow the user specified in the ID parameter.
Returns the unfollowed user in the requested format when successful. Returns a string describing the failure condition when unsuccessful.
This method calls https://api.twitter.com/1.1/friendships/destroy/[id].json

Parameters:
  `screenName` - the screen name of the user for whom to request a list of friends
Returns:
  User
Throws:
  `TwitterException` - when Twitter service or network is unavailable
Since:
  Twitter4J 2.0.1
See Also:
  POST friendships/destroy | Twitter Developers

#### updateFriendship

    Relationship updateFriendship(long userId,
                                  boolean enableDeviceNotification,
                                  boolean retweets)
                           throws TwitterException

Allows you to enable or disable retweets and device notifications from the specified user.
This method has not been finalized and the interface is subject to change in incompatible ways.
This method calls https://api.twitter.com/1.1/friendships/update.json

Parameters:
  `userId` - user id to update
  `enableDeviceNotification` - set true to enable device notification
  `retweets` - set true to enable retweets
Returns:
  Relationship
Throws:
  `TwitterException` - when Twitter service or network is unavailable
Since:
  Twitter4J 2.1.9
See Also:
  #newtwitter and the API - Twitter API Announcements | Google Group

#### updateFriendship

    Relationship updateFriendship(String screenName,
                                  boolean enableDeviceNotification,
                                  boolean retweets)
                           throws TwitterException

Allows you to enable or disable retweets and device notifications from the specified user.
This method has not been finalized and the interface is subject to change in incompatible ways.
This method calls https://api.twitter.com/1.1/friendships/update.json

Parameters:
  `screenName` - screen name to update
  `enableDeviceNotification` - set true to enable device notification
  `retweets` - set true to enable retweets
Returns:
  Relationship
Throws:
  `TwitterException` - when Twitter service or network is unavailable
Since:
  Twitter4J 2.1.9
See Also:
  #newtwitter and the API - Twitter API Announcements | Google Group

#### showFriendship

    Relationship showFriendship(long sourceId,
                                long targetId)
                         throws TwitterException

Returns detailed information about the relationship between two users.
This method calls https://api.twitter.com/1.1/friendships/show.json

Parameters:
  `sourceId` - the ID of the source user
  `targetId` - the ID of the target user
Returns:
  Relationship
Throws:
  `TwitterException` - when Twitter service or network is unavailable
Since:
  Twitter4J 2.1.0
See Also:
  GET friendships/show | Twitter Developers

#### showFriendship

    Relationship showFriendship(String sourceScreenName,
                                String targetScreenName)
                         throws TwitterException

Returns detailed information about the relationship between two users.
This method calls https://api.twitter.com/1.1/friendships/show.json

Parameters:
  `sourceScreenName` - the screen name of the source user
  `targetScreenName` - the screen name of the target user
Returns:
  Relationship
Throws:
  `TwitterException` - when Twitter service or network is unavailable
Since:
  Twitter4J 2.1.0
See Also:
  GET friendships/show | Twitter Developers

#### getFriendsList

    PagableResponseList<User> getFriendsList(long userId,
                                             long cursor)
                                      throws TwitterException

Returns a cursored collection of user objects for every user the specified user is following (otherwise known as their "friends").
At this time, results are ordered with the most recent following first — however, this ordering is subject to unannounced change and eventual consistency issues. Results are given in groups of 20 users and multiple "pages" of results can be navigated through using the next_cursor value in subsequent requests. See Using cursors to navigate collections for more information.
This method calls https://api.twitter.com/1.1/friends/list.json

Parameters:
  `userId` - The ID of the user for whom to return results for.
  `cursor` - Causes the results to be broken into pages of no more than 20 records at a time.
Returns:
  list of friends
Throws:
  `TwitterException` - when Twitter service or network is unavailable
Since:
  Twitter4J 3.0.2
See Also:
  GET friends/list | Twitter Developers

#### getFriendsList

    PagableResponseList<User> getFriendsList(long userId,
                                             long cursor,
                                             int count)
                                      throws TwitterException

Returns a cursored collection of user objects for every user the specified user is following (otherwise known as their "friends").
At this time, results are ordered with the most recent following first — however, this ordering is subject to unannounced change and eventual consistency issues. Results are given in groups of 20 users and multiple "pages" of results can be navigated through using the next_cursor value in subsequent requests. See Using cursors to navigate collections for more information.
This method calls https://api.twitter.com/1.1/friends/list.json

Parameters:
  `userId` - The ID of the user for whom to return results for.
  `cursor` - Causes the results to be broken into pages of no more than 20 records at a time.
  `count` - The number of users to return per page, up to a maximum of 200. Defaults to 20.
Returns:
  list of friends
Throws:
  `TwitterException` - when Twitter service or network is unavailable
See Also:
  GET friends/list | Twitter Developers

#### getFriendsList

    PagableResponseList<User> getFriendsList(String screenName,
                                             long cursor)
                                      throws TwitterException

Returns a cursored collection of user objects for every user the specified user is following (otherwise known as their "friends").
At this time, results are ordered with the most recent following first — however, this ordering is subject to unannounced change and eventual consistency issues. Results are given in groups of 20 users and multiple "pages" of results can be navigated through using the next_cursor value in subsequent requests. See Using cursors to navigate collections for more information.
This method calls https://api.twitter.com/1.1/friends/list.json

Parameters:
  `screenName` - The screen name of the user for whom to return results for.
  `cursor` - Causes the results to be broken into pages of no more than 20 records at a time.
Returns:
  list of friends
Throws:
  `TwitterException` - when Twitter service or network is unavailable
Since:
  Twitter4J 3.0.2
See Also:
  GET friends/list | Twitter Developers

#### getFriendsList

    PagableResponseList<User> getFriendsList(String screenName,
                                             long cursor,
                                             int count)
                                      throws TwitterException

Returns a cursored collection of user objects for every user the specified user is following (otherwise known as their "friends").
At this time, results are ordered with the most recent following first — however, this ordering is subject to unannounced change and eventual consistency issues. Results are given in groups of 20 users and multiple "pages" of results can be navigated through using the next_cursor value in subsequent requests. See Using cursors to navigate collections for more information.
This method calls https://api.twitter.com/1.1/friends/list.json

Parameters:
  `screenName` - The screen name of the user for whom to return results for.
  `cursor` - Causes the results to be broken into pages of no more than 20 records at a time.
  `count` - The number of users to return per page, up to a maximum of 200. Defaults to 20.
Returns:
  list of friends
Throws:
  `TwitterException` - when Twitter service or network is unavailable
Since:
  Twitter4J 4.0.2
See Also:
  GET friends/list | Twitter Developers

#### getFriendsList

    PagableResponseList<User> getFriendsList(long userId,
                                             long cursor,
                                             int count,
                                             boolean skipStatus,
                                             boolean includeUserEntities)
                                      throws TwitterException

Returns a cursored collection of user objects for every user the specified user is following (otherwise known as their "friends").
At this time, results are ordered with the most recent following first — however, this ordering is subject to unannounced change and eventual consistency issues. Results are given in groups of 20 users and multiple "pages" of results can be navigated through using the next_cursor value in subsequent requests. See Using cursors to navigate collections for more information.
This method calls https://api.twitter.com/1.1/friends/list.json

Parameters:
  `userId` - The ID of the user for whom to return results for.
  `cursor` - Causes the results to be broken into pages of no more than 20 records at a time.
  `count` - The number of users to return per page, up to a maximum of 200. Defaults to 20.
  `skipStatus` - When set to either true, statuses will not be included in the returned user objects.
  `includeUserEntities` - The user object entities node will be disincluded when set to false.
Returns:
  list of friends
Throws:
  `TwitterException` - when Twitter service or network is unavailable
Since:
  Twitter4J 4.0.2
See Also:
  GET friends/list | Twitter Developers

#### getFriendsList

    PagableResponseList<User> getFriendsList(String screenName,
                                             long cursor,
                                             int count,
                                             boolean skipStatus,
                                             boolean includeUserEntities)
                                      throws TwitterException

Returns a cursored collection of user objects for every user the specified user is following (otherwise known as their "friends").
At this time, results are ordered with the most recent following first — however, this ordering is subject to unannounced change and eventual consistency issues. Results are given in groups of 20 users and multiple "pages" of results can be navigated through using the next_cursor value in subsequent requests. See Using cursors to navigate collections for more information.
This method calls https://api.twitter.com/1.1/friends/list.json

Parameters:
  `screenName` - The screen name of the user for whom to return results for.
  `cursor` - Causes the results to be broken into pages of no more than 20 records at a time.
  `count` - The number of users to return per page, up to a maximum of 200. Defaults to 20.
  `skipStatus` - When set to either true, statuses will not be included in the returned user objects.
  `includeUserEntities` - The user object entities node will be disincluded when set to false.
Returns:
  list of friends
Throws:
  `TwitterException` - when Twitter service or network is unavailable
Since:
  Twitter4J 4.0.2
See Also:
  GET friends/list | Twitter Developers

#### getFollowersList

    PagableResponseList<User> getFollowersList(long userId,
                                               long cursor)
                                        throws TwitterException

Returns a cursored collection of user objects for users following the specified user.
At this time, results are ordered with the most recent following first — however, this ordering is subject to unannounced change and eventual consistency issues. Results are given in groups of 20 users and multiple "pages" of results can be navigated through using the next_cursor value in subsequent requests. See Using cursors to navigate collections for more information.
This method calls https://api.twitter.com/1.1/followers/list.json

Parameters:
  `userId` - The ID of the user for whom to return results for.
  `cursor` - Causes the results to be broken into pages of no more than 20 records at a time.
Returns:
  list of followers
Throws:
  `TwitterException` - when Twitter service or network is unavailable
Since:
  Twitter4J 3.0.2
See Also:
  GET followers/list | Twitter Developers

#### getFollowersList

    PagableResponseList<User> getFollowersList(String screenName,
                                               long cursor)
                                        throws TwitterException

Returns a cursored collection of user objects for users following the specified user.
At this time, results are ordered with the most recent following first — however, this ordering is subject to unannounced change and eventual consistency issues. Results are given in groups of 20 users and multiple "pages" of results can be navigated through using the next_cursor value in subsequent requests. See Using cursors to navigate collections for more information.
This method calls https://api.twitter.com/1.1/followers/list.json

Parameters:
  `screenName` - The screen name of the user for whom to return results for.
  `cursor` - Causes the results to be broken into pages of no more than 20 records at a time.
Returns:
  list of followers
Throws:
  `TwitterException` - when Twitter service or network is unavailable
Since:
  Twitter4J 3.0.2
See Also:
  GET followers/list | Twitter Developers

#### getFollowersList

    PagableResponseList<User> getFollowersList(long userId,
                                               long cursor,
                                               int count)
                                        throws TwitterException

Returns a cursored collection of user objects for users following the specified user.
At this time, results are ordered with the most recent following first — however, this ordering is subject to unannounced change and eventual consistency issues. Results are given in groups of 20 users and multiple "pages" of results can be navigated through using the next_cursor value in subsequent requests. See Using cursors to navigate collections for more information.
This method calls https://api.twitter.com/1.1/followers/list.json

Parameters:
  `userId` - The ID of the user for whom to return results for.
  `cursor` - Causes the results to be broken into pages of no more than 20 records at a time.
  `count` - The number of users to return per page, up to a maximum of 200. Defaults to 20.
Returns:
  list of followers
Throws:
  `TwitterException` - when Twitter service or network is unavailable
Since:
  Twitter4J 3.0.6
See Also:
  GET followers/list | Twitter Developers

#### getFollowersList

    PagableResponseList<User> getFollowersList(String screenName,
                                               long cursor,
                                               int count)
                                        throws TwitterException

Returns a cursored collection of user objects for users following the specified user.
At this time, results are ordered with the most recent following first — however, this ordering is subject to unannounced change and eventual consistency issues. Results are given in groups of 20 users and multiple "pages" of results can be navigated through using the next_cursor value in subsequent requests. See Using cursors to navigate collections for more information.
This method calls https://api.twitter.com/1.1/followers/list.json

Parameters:
  `screenName` - The screen name of the user for whom to return results for.
  `cursor` - Causes the results to be broken into pages of no more than 20 records at a time.
  `count` - The number of users to return per page, up to a maximum of 200. Defaults to 20.
Returns:
  list of followers
Throws:
  `TwitterException` - when Twitter service or network is unavailable
Since:
  Twitter4J 3.0.6
See Also:
  GET followers/list | Twitter Developers

#### getFollowersList

    PagableResponseList<User> getFollowersList(long userId,
                                               long cursor,
                                               int count,
                                               boolean skipStatus,
                                               boolean includeUserEntities)
                                        throws TwitterException

Returns a cursored collection of user objects for users following the specified user.
At this time, results are ordered with the most recent following first — however, this ordering is subject to unannounced change and eventual consistency issues. Results are given in groups of 20 users and multiple "pages" of results can be navigated through using the next_cursor value in subsequent requests. See Using cursors to navigate collections for more information.
This method calls https://api.twitter.com/1.1/followers/list.json

Parameters:
  `userId` - The ID of the user for whom to return results for.
  `cursor` - Causes the results to be broken into pages of no more than 20 records at a time.
  `count` - The number of users to return per page, up to a maximum of 200. Defaults to 20.
  `skipStatus` - When set to either true, statuses will not be included in the returned user objects.
  `includeUserEntities` - The user object entities node will be disincluded when set to false.
Returns:
  list of followers
Throws:
  `TwitterException` - when Twitter service or network is unavailable
Since:
  Twitter4J 4.0.2
See Also:
  GET followers/list | Twitter Developers

#### getFollowersList

    PagableResponseList<User> getFollowersList(String screenName,
                                               long cursor,
                                               int count,
                                               boolean skipStatus,
                                               boolean includeUserEntities)
                                        throws TwitterException

Returns a cursored collection of user objects for users following the specified user.
At this time, results are ordered with the most recent following first — however, this ordering is subject to unannounced change and eventual consistency issues. Results are given in groups of 20 users and multiple "pages" of results can be navigated through using the next_cursor value in subsequent requests. See Using cursors to navigate collections for more information.
This method calls https://api.twitter.com/1.1/followers/list.json

Parameters:
  `screenName` - The screen name of the user for whom to return results for.
  `cursor` - Causes the results to be broken into pages of no more than 20 records at a time.
  `count` - The number of users to return per page, up to a maximum of 200. Defaults to 20.
  `skipStatus` - When set to either true, statuses will not be included in the returned user objects.
  `includeUserEntities` - The user object entities node will be disincluded when set to false.
Returns:
  list of followers
Throws:
  `TwitterException` - when Twitter service or network is unavailable
Since:
  Twitter4J 4.0.2
See Also:
  GET followers/list | Twitter Developers